'use strict'
const async = require('async')
const config = require('./rc')().get()

const api = require('./api.js')(config.medx.username, config.medx.password)
const store = require('./store.js')

module.exports = (key, answer, delteAllProfiles, handleResponse) => {
  const handleData = (err, data, dropLast) => {
    if (err) return handleResponse(err)
    if (!dropLast) return addItem(key, data)
    store.drop(key, (err) => {
      if (err) return handleResponse(err)
      addItem(key, data)
    })
  }

  const addItem = (key, data) => {
    store.setState(key, data, (err) => {
      if (err) return handleResponse(err)
      handleResponse(null, data)
    })
  }

  if (!api.isLoggedIn()) return api.login(delteAllProfiles, handleData)

  store.setState(`${key}-ANSWER`, answer, () => {})

  async.series({
    state: (cb) => store.getState(key, cb),
    prevState: (cb) => store.getPrevState(key, cb),
    prevAnswer: (cb) => store.getPrevState(`${key}-ANSWER`, cb)
  }, (err, res) => {
    if (err) throw err
    api.ask(answer, res.state, res.prevState, res.prevAnswer, key === 'cli', handleData)
  })
}
