const async = require('async')
const config = require('./rc')().get()

const redis = config.persist ? require('redis') : require('redis-js')
const client = redis.createClient()

exports.setState = (key, state, cb) => client.rpush(key, JSON.stringify(state), cb)
exports.deleteState = (key, cb) => client.del(key, cb)

exports.getState = (key, cb) => {
  client.lindex(key, -1, (err, reply) => {
    cb(err, !err && JSON.parse(reply))
  })
}

exports.getPrevState = (key, cb) => {
  client.lindex(key, -2, (err, reply) => {
    cb(err, !err && reply && JSON.parse(reply))
  })
}

exports.drop = (key, cb) => {
  async.series([
    (cb) => client.rpop(key, cb),
    (cb) => client.rpop(key, cb),
    (cb) => client.rpop(`${key}-ANSWER`, cb)
  ], (err) => {
    cb(err, !err && null)
  })
}
